<script>
import {useStore} from "vuex";
import ProductService from "@/service/ProductService";
import {HOST_API, UPLOAD_FILE_PATH} from "@/vars";
import {useToast} from "primevue/usetoast";
import EventBus from "@/utils/event-bus";

export default {
  name: 'ProjectsQualified',
  setup() {
    const store = useStore()
    const productService = new ProductService();
    const toast = useToast();
    return {
      store,
      productService,
      toast
    }
  },
  data: () => ({
    project: {
      title: null,
      description: null,
      status: null,
      categories: null
    },
    url: UPLOAD_FILE_PATH,
    categoriesList: null
  }),
  async created() {
  },
  computed: {
  },
  mounted() {
    this.categoriesList = this.store.state.categories
  },
  methods: {
    createProject() {
      fetch(HOST_API + `/projects/create/`, {
        method: 'POST',
        body: JSON.stringify(this.project),
        headers: {
          'Content-Type': 'application/json',
          'Authorization': `Bearer ${this.store.state.authentication.access}`,
        }
      }).then(res => res.json()).then(response => {
        console.log(response)
        EventBus.emit('updated-project', true)
        this.toast.add({ severity: 'success', summary: response.message, detail: `Project ID: ${response.id}`, life: 3000 });
        this.$router.push({name: 'project_edit', params: {'id': response.id}});
      })
    },
    sendProject(){
      this.project.status = "send"
      this.createProject()
    },
    onAdvancedUpload(even) {
      alert(even)
    },
    beforeUpload(event){
      console.log(event)
      event.xhr.setRequestHeader("Authorization", `Bearer ${this.store.state.authentication.access}`);
    }
  }
}
</script>

<template>
  <div class="grid">
    <div class="col-12">
      <div class="card">
        <h5>Crear proyecto</h5>
        <div class="p-fluid formgrid grid">
          <div class="field col-12 md:col-8">
            <label for="firstname2">Título</label>
            <InputText id="firstname2" type="text" v-model="project.title"/>
          </div>
          <div class="field col-12 md:col-4">
            <label for="state">Categoría</label>
            <MultiSelect v-model="project.categories" :options="categoriesList" optionLabel="name"
                         placeholder="Categorías"
                         :filter="true">
              <template #value="slotProps">
                <div class="inline-flex align-items-center py-1 px-2 bg-primary text-primary border-round mr-2"
                     v-for="option of slotProps.value" :key="option.id">
                  <span :class="'mr-2 flag flag-co'" style="width: 18px; height: 12px"/>
                  <div>{{ option.name }}</div>
                </div>
                <template v-if="!slotProps.value || slotProps.value.length === 0">
                  <div class="p-1">Seleccione una categoría para este proyecto</div>
                </template>
              </template>
              <template #option="slotProps">
                <div class="flex align-items-center">
                  <span :class="'mr-2 flag flag-co'" style="width: 18px; height: 12px"/>
                  <div>{{ slotProps.option.name }}</div>
                </div>
              </template>
            </MultiSelect>
          </div>
          <div class="field col-12">
            <label for="address">Descripción</label>
            <Textarea id="address" rows="4"  v-model="project.description"/>
          </div>
          <div class="field col-12">
            <h5>Archivos</h5>
            <FileUpload name="demo[]"
                        :url="url"
                        @upload="onAdvancedUpload($event)"
                        @before-send="beforeUpload($event)"
                        :multiple="true"
                        accept="image/*" :maxFileSize="1000000">
              <template #empty>
                <p>Drag and drop files to here to upload.</p>
              </template>
            </FileUpload>
          </div>
        </div>
        <Button @click="createProject" label="Guardar como borrador" class="p-button-outlined p-button-info mr-2 mb-2" />
        <Button @click="sendProject" label="Enviar a calificación" class="p-button-outlined p-button-success mr-2 mb-2" />
      </div>
    </div>
  </div>
</template>
